// Form1.h (Test Server)

#pragma once

#include "Server.h"

namespace TestServer {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	/// <summary>
	/// Zusammenfassung fr Form1
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
  public:
    Form1(void)  // Test Server
    {
      InitializeComponent();
      //
      //TODO: Konstruktorcode hier hinzufgen.
      //

      if (Server::Startup(gcnew Action(this, &Form1::ServerShutdownRequestCallback),
        gcnew Action<int>(this, &Form1::ServerStatusReportCallback)))
      {
        timer1->Start();
      } else {
        Text += " (non-primary)";
        MessageBox::Show("There's already an instance of the server running. Please use that.",
          Text, MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
      }
      lblGuiThreadId->Text = String::Format("GUI thread ID: {0}", Thread::CurrentThread->ManagedThreadId);
    }

  protected:
    /// <summary>
    /// Verwendete Ressourcen bereinigen.
    /// </summary>
    ~Form1()  // Test Server
    {
      timer1->Stop();
      Server::Shutdown();

      if (components)
      {
        delete components;
      }
    }

  private: System::Windows::Forms::Label^  lblGuiThreadId;
  protected: 
  private: System::Windows::Forms::Label^  lblRemoteAccessThreadId;
  private: System::Windows::Forms::Label^  lblServerObjectCount;
  private: System::Windows::Forms::Timer^  timer1;
  private: System::Windows::Forms::Label^  label1;
  private: System::Windows::Forms::ListBox^  lstbInstanceStatus;
  private: System::Windows::Forms::Label^  lblHeartbeat;
  private: System::ComponentModel::IContainer^  components;

	private:
		/// <summary>
		/// Erforderliche Designervariable.
		/// </summary>


#pragma region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung.
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		void InitializeComponent(void)
		{
      this->components = (gcnew System::ComponentModel::Container());
      this->lblGuiThreadId = (gcnew System::Windows::Forms::Label());
      this->lblRemoteAccessThreadId = (gcnew System::Windows::Forms::Label());
      this->lblServerObjectCount = (gcnew System::Windows::Forms::Label());
      this->timer1 = (gcnew System::Windows::Forms::Timer(this->components));
      this->label1 = (gcnew System::Windows::Forms::Label());
      this->lstbInstanceStatus = (gcnew System::Windows::Forms::ListBox());
      this->lblHeartbeat = (gcnew System::Windows::Forms::Label());
      this->SuspendLayout();
      // 
      // lblGuiThreadId
      // 
      this->lblGuiThreadId->AutoSize = true;
      this->lblGuiThreadId->Location = System::Drawing::Point(12, 9);
      this->lblGuiThreadId->Name = L"lblGuiThreadId";
      this->lblGuiThreadId->Size = System::Drawing::Size(35, 13);
      this->lblGuiThreadId->TabIndex = 0;
      this->lblGuiThreadId->Text = L"label1";
      // 
      // lblRemoteAccessThreadId
      // 
      this->lblRemoteAccessThreadId->AutoSize = true;
      this->lblRemoteAccessThreadId->Location = System::Drawing::Point(12, 22);
      this->lblRemoteAccessThreadId->Name = L"lblRemoteAccessThreadId";
      this->lblRemoteAccessThreadId->Size = System::Drawing::Size(260, 13);
      this->lblRemoteAccessThreadId->TabIndex = 1;
      this->lblRemoteAccessThreadId->Text = L"Remote access thread ID: (waiting for remote access)";
      // 
      // lblServerObjectCount
      // 
      this->lblServerObjectCount->AutoSize = true;
      this->lblServerObjectCount->Location = System::Drawing::Point(12, 35);
      this->lblServerObjectCount->Name = L"lblServerObjectCount";
      this->lblServerObjectCount->Size = System::Drawing::Size(177, 13);
      this->lblServerObjectCount->TabIndex = 2;
      this->lblServerObjectCount->Text = L"Live server object count: (unknown)";
      // 
      // timer1
      // 
      this->timer1->Interval = 500;
      this->timer1->Tick += gcnew System::EventHandler(this, &Form1::timer1_Tick);
      // 
      // label1
      // 
      this->label1->AutoSize = true;
      this->label1->Location = System::Drawing::Point(12, 58);
      this->label1->Name = L"label1";
      this->label1->Size = System::Drawing::Size(82, 13);
      this->label1->TabIndex = 3;
      this->label1->Text = L"Instance status:";
      // 
      // lstbInstanceStatus
      // 
      this->lstbInstanceStatus->BackColor = System::Drawing::SystemColors::Control;
      this->lstbInstanceStatus->Location = System::Drawing::Point(12, 74);
      this->lstbInstanceStatus->Name = L"lstbInstanceStatus";
      this->lstbInstanceStatus->SelectionMode = System::Windows::Forms::SelectionMode::None;
      this->lstbInstanceStatus->Size = System::Drawing::Size(268, 95);
      this->lstbInstanceStatus->TabIndex = 4;
      // 
      // lblHeartbeat
      // 
      this->lblHeartbeat->AutoSize = true;
      this->lblHeartbeat->Font = (gcnew System::Drawing::Font(L"Symbol", 14, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
        static_cast<System::Byte>(0)));
      this->lblHeartbeat->Location = System::Drawing::Point(248, 48);
      this->lblHeartbeat->Name = L"lblHeartbeat";
      this->lblHeartbeat->Size = System::Drawing::Size(24, 23);
      this->lblHeartbeat->TabIndex = 5;
      this->lblHeartbeat->Text = L"";
      this->lblHeartbeat->Visible = false;
      // 
      // Form1
      // 
      this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
      this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
      this->ClientSize = System::Drawing::Size(292, 184);
      this->Controls->Add(this->lblHeartbeat);
      this->Controls->Add(this->lstbInstanceStatus);
      this->Controls->Add(this->label1);
      this->Controls->Add(this->lblServerObjectCount);
      this->Controls->Add(this->lblRemoteAccessThreadId);
      this->Controls->Add(this->lblGuiThreadId);
      this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedSingle;
      this->MaximizeBox = false;
      this->Name = L"Form1";
      this->Text = L"WCF Share Test Server";
      this->FormClosing += gcnew System::Windows::Forms::FormClosingEventHandler(this, &Form1::Form1_FormClosing);
      this->ResumeLayout(false);
      this->PerformLayout();

    }
#pragma endregion

  // Other member functions

  private:
    void ServerShutdownRequestCallback();
    void ServerStatusReportCallback(int nThreadId);

  // Event handlers

  private:
    System::Void timer1_Tick(System::Object^  sender, System::EventArgs^  e);
    System::Void Form1_FormClosing(System::Object^  sender, System::Windows::Forms::FormClosingEventArgs^  e);
};
}

